Attribute VB_Name = "DXModule"
Option Explicit

'DirectX Objekte
Public DX As DirectX8
'DirectPlay Objekte
Public DPP As DirectPlay8Peer
Public DPA As DirectPlay8Address
'eindeutige GUID (erzeugt mit dx.CreateNewGuid)
Public Const GameGUID As String = "{99E26B38-E6A1-4195-BEEE-6F94425015B4}"

'DirectX und DirectPlay initialisieren
Public Function DXInit() As Boolean
    Dim i As Integer
    Dim intCountSP As Integer
    Dim bolTCPSP As Boolean
    Set DX = New DirectX8
    Set DPP = DX.DirectPlayPeerCreate
    'wir teilen dem DirectPlay mit das unser frmDPEvents Fenster
    'alles Messages bekommen soll (dazu mssen aber auch
    'alle DirectPlay8 Events im Fenster implementiert sein)
    DPP.RegisterMessageHandler frmDPEvents
    Set DPA = DX.DirectPlayAddressCreate
    'dieses Spiel arbeitet nur mit dem TCP-Protokoll
    'ist dieses Protokoll nicht auf dem PC eingerichtet,
    'dann beendet sich das Programm von selbst
    intCountSP = DPP.GetCountServiceProviders
    If intCountSP = 0 Then
        MsgBox "Keine Service Provider gefunden.", vbInformation
        Exit Function
    End If
    For i = 1 To intCountSP
        If InStr(1, DPP.GetServiceProvider(i).Name, "TCP") > 0 Then
            bolTCPSP = True
            DPA.SetSP DPP.GetServiceProvider(i).Guid
            Exit For
        End If
    Next
    If bolTCPSP = False Then
        MsgBox "Keinen TCP-Service Provider gefunden.", vbInformation
        Exit Function
    End If
    DXInit = True
    Exit Function
ErrOut:
    DXInit = False
End Function

'beenden des Spieles
'bevor das Progamm ganz beendet wird lassen wir dem DirectPlay
'Zeit um die Nachricht an alle angemeldeten Client's zu verschicken
'damit ein anderer Client die "Host"-Funktion bernehmen kann
Public Sub Terminate()
    On Error Resume Next
    'wenn wir das Spiel hosten schicken wir noch eine
    'entsprechende Nachricht an alle Clients und dazu
    'auch gleich die aktuelle Spielerliste
    If bolWirHostenDasSpiel Then
        If Not (DPP Is Nothing) Then
            SendeHostNachricht SPIELER(intMeineArrayID).Name & " hat das Spiel verlassen ..."
            LoescheSpielerAusArray SPIELER(intMeineArrayID).DPlayID
            SendeSpielerListe
            DoSleep 50
        End If
    End If
    If Not (DPP Is Nothing) Then DPP.UnRegisterMessageHandler
    If Not (DPP Is Nothing) Then DPP.Close
    DoSleep 50
    If Not (DPP Is Nothing) Then Set DPP = Nothing
    If Not (DPA Is Nothing) Then Set DPA = Nothing
    Set DX = Nothing
    Unload frmDPEvents
    End
End Sub

