Attribute VB_Name = "MsgModule"
Option Explicit

'Alle Nachrichten in dem Spiel haben
'einen eindeutigen Schlssel.
'Damit Host und Client wissen worum
'es in der Nachricht geht.
Public Enum const_msgid
    MsgSpielerListe         'Liste der Spieler
    MsgSpielStart           'der Host hat das Spiel gestartet
    MsgChat                 'normale Chat-Nachricht
    MsgHost                 'Host-Nachricht
    MsgWuerfeluebergabe     'bergabe des Wrfels an den nchsten Spieler
    MsgWuerfelzahl          'Zahl die gewrfelt wurde
    MsgZug                  'Spieler hat eine Figur bewegt
    MsgGewonnen             'na was woll
End Enum

'gerade bei einen Runden-basierenden Spiel wie ein Brettspiel ist es
'wichtig das Nachrichten garantiert bei den Clients ankommen
'dafr gibt es den Flag DPNSEND_GUARANTEED

'wenn wir selbst die Nachricht nicht noch einmal bekommen wollen
'wird DPNSEND_NOLOOPBACK verwendet

'wenn es uns egal ist ob die Nachricht ankommt oder nicht kann
'DPNSEND_NOCOMPLETE verwendet werden. Meist verwendet man diesen
'Flag fr Chat-Nachrichten

'sendet die komplette Liste aller Spieler an alle Clients
Public Sub SendeSpielerListe()
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    Dim i As Integer
    msgid = MsgSpielerListe
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und jetzt die eigentliche Nachricht
    For i = 0 To 3
        AddDataToBuffer newbuf(), SPIELER(i).DPlayID, LenB(SPIELER(i).DPlayID), lngoffset
        If SPIELER(i).Aktiv Then
            AddStringToBuffer newbuf(), SPIELER(i).Name, lngoffset
        Else
            AddStringToBuffer newbuf(), "niemand", lngoffset
        End If
    Next
    'und ab die Post
    'sie soll auf jeden Fall ankommen DPNSEND_GUARANTEED
    'aber wir selbst wollen sie nicht noch einmal bekommen DPNSEND_NOLOOPBACK
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_NOLOOPBACK Or DPNSEND_GUARANTEED
End Sub

'sendet eine ganz normale Chat-Nachricht
Public Sub SendeChatNachricht(ByVal strNachricht As String)
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgChat
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und jetzt die eigentliche Nachricht
    AddStringToBuffer newbuf(), strNachricht, lngoffset
    'und ab die Post
    'ist uns egal ob die Nachricht ankommt oder nicht und wir selber bekommen sie auch noch einmal
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_NOCOMPLETE
End Sub

'sendet den Spiel-Start, damit alle Clients wissen jetzt geht es los
Public Sub SendeSpielStart()
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgSpielStart
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und ab die Post
    'die Nachricht soll auf jeden Fall ankommen aber wir selber wollen sie nicht noch einmal bekommen
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_NOLOOPBACK Or DPNSEND_GUARANTEED
End Sub

'sendet eine Host-Nachricht
'ist im Prinzip wie eine Chat-Nachricht, nur das die Empfnger
'ein klein wenig anders auswerten
Public Sub SendeHostNachricht(ByVal strNachricht As String)
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgHost
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und jetzt die eigentliche Nachricht
    AddStringToBuffer newbuf(), strNachricht, lngoffset
    'die Nachricht soll auf jeden Fall ankommen aber wir selber wollen sie nicht noch einmal bekommen
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_NOLOOPBACK Or DPNSEND_GUARANTEED
End Sub

'sendet den Wrfel an den nchsten Spieler (bildlich gesprochen)
'ist der Spieler fertig dann bekommen alle eine Nachricht
'das der nchste Spieler an der Reihe ist
Public Sub SendeWuerfeluebergabe(ByVal intSpieler As Integer)
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgWuerfeluebergabe
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und jetzt die eigentliche Nachricht
    AddDataToBuffer newbuf(), intSpieler, LenB(intSpieler), lngoffset
    'die Nachricht soll auf jeden Fall ankommen und wir selber bekommen sie auch gleich noch einmal
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_GUARANTEED
End Sub

'das was der Spieler gewrfelt hat wird an alle Clients geschickt,
'damit die auch bescheid wissen
Public Sub SendeWuerfelzahl(ByVal intWuerfelzahl As Integer)
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgWuerfelzahl
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und jetzt die eigentliche Nachricht
    AddDataToBuffer newbuf(), intWuerfelzahl, LenB(intWuerfelzahl), lngoffset
    'die Nachricht soll auf jeden Fall ankommen aber wir selber wollen sie nicht noch einmal bekommen
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_NOLOOPBACK Or DPNSEND_GUARANTEED
End Sub

'wenn ein Spieler einen Figur bewegt hat,
'dann bekommen alle Clients die Bewegung als Nachricht
'sonst wissen die ja nicht das sich auf dem Brett etwas getan hat
Public Sub SendeZug(ByVal spid As Integer, ByVal fid As Integer, _
                    ByVal vonx As Integer, ByVal vony As Integer, _
                    ByVal nachx As Integer, ByVal nachy As Integer)
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgZug
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'und jetzt die eigentliche Nachricht
    AddDataToBuffer newbuf(), spid, LenB(spid), lngoffset
    AddDataToBuffer newbuf(), fid, LenB(fid), lngoffset
    AddDataToBuffer newbuf(), vonx, LenB(vonx), lngoffset
    AddDataToBuffer newbuf(), vony, LenB(vony), lngoffset
    AddDataToBuffer newbuf(), nachx, LenB(nachx), lngoffset
    AddDataToBuffer newbuf(), nachy, LenB(nachy), lngoffset
    'die Nachricht soll auf jeden Fall ankommen, aber wir selber wollen sie nicht noch einmal bekommen
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_NOLOOPBACK Or DPNSEND_GUARANTEED
End Sub

'sendet eine Nachricht an alle Clients das wir gewonnen haben ..... jipiiiii
Public Sub SendeGewonnen()
    Dim newbuf() As Byte
    Dim lngoffset As Long
    Dim msgid As Long
    msgid = MsgGewonnen
    lngoffset = NewBuffer(newbuf())
    'zuerst wird die ID der Nachricht verpackt - mehr ist in der Nachricht eh nicht
    AddDataToBuffer newbuf(), msgid, LenB(msgid), lngoffset
    'die Nachricht soll auf jeden Fall ankommen, aber wir selber wollen sie nicht noch einmal bekommen
    DPP.SendTo DPNID_ALL_PLAYERS_GROUP, newbuf(), 0, DPNSEND_GUARANTEED Or DPNSEND_NOLOOPBACK
End Sub
