Attribute VB_Name = "SpielModule"
Option Explicit

'in diesem Modul spielt sich das eigentlich Spiel ab

'ich habe diesem Teil weniger Beachtung geschenkt als dem DirectPlay-Bereich,
'da ich einen beispielhaften Einsatz zeigen wollte

'dennoch werde ich versuchen den Spielaufbau und Ablauf so gut es geht
'zu erklren, ich hoffe die Codierung ist transparent genug

'ein einfacher Datentyp fr 2D-Koordinaten
Public Type strc_XY
    X               As Integer
    Y               As Integer
End Type

'Struktur fr die Spieler mit allen ihren Daten
Public Type strc_Spieler
    DPlayID         As Long
    Aktiv           As Boolean
    Name            As String
    WuerfelZahl     As Integer
    Figur(3)        As strc_XY
    ZuHause(3)      As Boolean
    Startfeld       As strc_XY
    ZugMoeglich(3)  As Boolean
    ZugVon(3)       As strc_XY
    ZugNach(3)      As strc_XY
    HausFeld(3)     As strc_XY
    Weg(43)         As strc_XY
    ImZiel(3)       As Boolean
End Type

'Array fr die insgesamt 4 Spieler
Public SPIELER(3) As strc_Spieler

'ein einfacher Datentyp um die Felder auf dem Spielfeld besser beschreiben zu knnen
Public Type strc_Feld
    SpielerArrayID   As Integer
    FigurArrayID     As Integer
End Type

'ein Array fr unser Spiel (11x11 Felder)
Public SPIELFELD(10, 10) As strc_Feld

'welcher von den 4 Spielern sind wir eigentlich (damit wir wissen an welcher Stelle im Array wir sind)
Public intMeineArrayID As Integer
'wer hat eigentlich den Wrfel ? (welcher Spieler im Array)
Public intWerHatDenWuerfel As Integer
'das Spiel luft schon, kein weiterer Spieler kann dazu
Public bolDasSpielLaeuft As Boolean

'wenn wir fertig sind geben wir den Wrfel an den nchsten Spieler
'weiter, dafr verschicken wir auch die entsprechende Nachricht
Public Sub GibWuerfelAnNaechstenSpieler()
    Do
        intWerHatDenWuerfel = intWerHatDenWuerfel + 1
        If intWerHatDenWuerfel > 3 Then intWerHatDenWuerfel = 0
    Loop Until SPIELER(intWerHatDenWuerfel).Aktiv
    SendeWuerfeluebergabe intWerHatDenWuerfel
End Sub

'hat sich ein weitere Spieler am Spiel angemeldet, dann Erstellen
'wir einen Eintrag im Array
Public Function ErstelleNeuenSpieler(ByVal strName As String, ByVal lngPID As Long) As Integer
    Dim i As Integer
    For i = 0 To 3
        If SPIELER(i).Aktiv = False Then
            SPIELER(i).Aktiv = True
            SPIELER(i).Name = strName
            SPIELER(i).DPlayID = lngPID
            ErstelleNeuenSpieler = i
            Exit For
        End If
    Next
End Function

'hat der Spieler das Spiel verlassen, egal ob im Startup oder im eigentlichen Spiel
'dann wird das Array bereinigt
Public Sub LoescheSpielerAusArray(ByVal lngPID As Long)
    Dim i As Integer
    For i = 0 To 3
        If SPIELER(i).DPlayID = lngPID Then
            SPIELER(i).Aktiv = False
            SPIELER(i).Name = ""
            SPIELER(i).DPlayID = 0
            Exit For
        End If
    Next
End Sub

'liefert den Namen des Spielers aufgrund seiner DirectPlay-ID
Public Function SpielerName(ByVal lngPID As Long) As String
    Dim i As Integer
    For i = 0 To 3
        If SPIELER(i).DPlayID = lngPID Then
            SpielerName = SPIELER(i).Name
            Exit For
        End If
    Next
End Function

'zeichnet das Spielbrett und die Spieler-Figuren in die PictureBox
Public Sub ZeichneFiguren()
    Dim i As Integer, j As Integer
    Dim intX As Integer, intY As Integer
    frmGame.pic_Game.PaintPicture frmGame.pic_bg.Picture, 0, 0, , , , , , , vbSrcCopy
    For i = 0 To 3
        If SPIELER(i).Aktiv Then
            For j = 0 To 3
                intX = (SPIELER(i).Figur(j).X * 31) + 3
                intY = (SPIELER(i).Figur(j).Y * 31) + 3
                frmGame.pic_Game.PaintPicture frmGame.pic_maske.Picture, _
                    intX, intY, , , , , , , vbMergePaint
                frmGame.pic_Game.PaintPicture frmGame.pic_figur(i).Picture, _
                    intX, intY, , , , , , , vbSrcAnd
            Next j
        End If
    Next i
End Sub

'befllt alle wichtigen Arrays fr das Spiel
Public Sub ErstelleSpielArrays()
    Dim i As Integer, j As Integer
    'das Spielfeld wird bereinigt, keine Figur befindet sich auf dem Spielfeld
    For i = 0 To 10
        For j = 0 To 10
            SPIELFELD(i, j).SpielerArrayID = -1
            SPIELFELD(i, j).FigurArrayID = -1
        Next j
    Next i
    'jeder Spieler bekommt sein persnliches Startfeld
    SPIELER(0).Startfeld.X = 0: SPIELER(0).Startfeld.Y = 4
    SPIELER(1).Startfeld.X = 6: SPIELER(1).Startfeld.Y = 0
    SPIELER(2).Startfeld.X = 10: SPIELER(2).Startfeld.Y = 6
    SPIELER(3).Startfeld.X = 4: SPIELER(3).Startfeld.Y = 10
    'die 4 Figuren eines jeden Spielers werden in seinem "Heimbereich"
    'positioniert
    SPIELER(0).Figur(0).X = 0: SPIELER(0).Figur(0).Y = 0
    SPIELER(0).Figur(1).X = 1: SPIELER(0).Figur(1).Y = 0
    SPIELER(0).Figur(2).X = 0: SPIELER(0).Figur(2).Y = 1
    SPIELER(0).Figur(3).X = 1: SPIELER(0).Figur(3).Y = 1
    SPIELER(1).Figur(0).X = 10: SPIELER(1).Figur(0).Y = 0
    SPIELER(1).Figur(1).X = 9: SPIELER(1).Figur(1).Y = 0
    SPIELER(1).Figur(2).X = 10: SPIELER(1).Figur(2).Y = 1
    SPIELER(1).Figur(3).X = 9: SPIELER(1).Figur(3).Y = 1
    SPIELER(2).Figur(0).X = 10: SPIELER(2).Figur(0).Y = 10
    SPIELER(2).Figur(1).X = 9: SPIELER(2).Figur(1).Y = 10
    SPIELER(2).Figur(2).X = 10: SPIELER(2).Figur(2).Y = 9
    SPIELER(2).Figur(3).X = 9: SPIELER(2).Figur(3).Y = 9
    SPIELER(3).Figur(0).X = 0: SPIELER(3).Figur(0).Y = 10
    SPIELER(3).Figur(1).X = 1: SPIELER(3).Figur(1).Y = 10
    SPIELER(3).Figur(2).X = 0: SPIELER(3).Figur(2).Y = 9
    SPIELER(3).Figur(3).X = 1: SPIELER(3).Figur(3).Y = 9
    'jetzt setzen wir die Figuren der Spieler in das Spielfeld
    'damit sie dann auch bei Beginn des Spieles gleich richtig
    'positioniert sind wenn man mit der Maus darber fhrt oder
    'anklickt
    'und wir setzen auch gleich den Zu Hause Flag - der ist wichtig
    'wenn man wrfelt und eine Figur auf das Startfeld setzen kann
    For i = 0 To 3
        For j = 0 To 3
            SPIELFELD(SPIELER(i).Figur(j).X, SPIELER(i).Figur(j).Y).SpielerArrayID = i
            SPIELFELD(SPIELER(i).Figur(j).X, SPIELER(i).Figur(j).Y).FigurArrayID = j
            SPIELER(i).ZuHause(j) = True
            SPIELER(i).HausFeld(j).X = SPIELER(i).Figur(j).X
            SPIELER(i).HausFeld(j).Y = SPIELER(i).Figur(j).Y
        Next j
    Next i
    'so, dieser Teil ist nicht besonders schn gelst
    'man knnte dies auch aus einer Datei einlesen, oder
    'einen Pathfinder verwenden oder vielleicht "berechnen"
    'Es geht um den Weg auf dem Spielbrett. Der ist ja um
    'Uhrzeigersinn.
    'Ich habe es so gelst das fr jeden Spieler ein eigenes
    'Array zur Verfgung steht mit dem der Weg vom Start bis
    'zum Ziel vorgegeben ist.
    With SPIELER(0)
        .Weg(0).X = 0: .Weg(0).Y = 4
        .Weg(1).X = 1: .Weg(1).Y = 4
        .Weg(2).X = 2: .Weg(2).Y = 4
        .Weg(3).X = 3: .Weg(3).Y = 4
        .Weg(4).X = 4: .Weg(4).Y = 4
        .Weg(5).X = 4: .Weg(5).Y = 3
        .Weg(6).X = 4: .Weg(6).Y = 2
        .Weg(7).X = 4: .Weg(7).Y = 1
        .Weg(8).X = 4: .Weg(8).Y = 0
        .Weg(9).X = 5: .Weg(9).Y = 0
        .Weg(10).X = 6: .Weg(10).Y = 0
        .Weg(11).X = 6: .Weg(11).Y = 1
        .Weg(12).X = 6: .Weg(12).Y = 2
        .Weg(13).X = 6: .Weg(13).Y = 3
        .Weg(14).X = 6: .Weg(14).Y = 4
        .Weg(15).X = 7: .Weg(15).Y = 4
        .Weg(16).X = 8: .Weg(16).Y = 4
        .Weg(17).X = 9: .Weg(17).Y = 4
        .Weg(18).X = 10: .Weg(18).Y = 4
        .Weg(19).X = 10: .Weg(19).Y = 5
        .Weg(20).X = 10: .Weg(20).Y = 6
        .Weg(21).X = 9: .Weg(21).Y = 6
        .Weg(22).X = 8: .Weg(22).Y = 6
        .Weg(23).X = 7: .Weg(23).Y = 6
        .Weg(24).X = 6: .Weg(24).Y = 6
        .Weg(25).X = 6: .Weg(25).Y = 7
        .Weg(26).X = 6: .Weg(26).Y = 8
        .Weg(27).X = 6: .Weg(27).Y = 9
        .Weg(28).X = 6: .Weg(28).Y = 10
        .Weg(29).X = 5: .Weg(29).Y = 10
        .Weg(30).X = 4: .Weg(30).Y = 10
        .Weg(31).X = 4: .Weg(31).Y = 9
        .Weg(32).X = 4: .Weg(32).Y = 8
        .Weg(33).X = 4: .Weg(33).Y = 7
        .Weg(34).X = 4: .Weg(34).Y = 6
        .Weg(35).X = 3: .Weg(35).Y = 6
        .Weg(36).X = 2: .Weg(36).Y = 6
        .Weg(37).X = 1: .Weg(37).Y = 6
        .Weg(38).X = 0: .Weg(38).Y = 6
        .Weg(39).X = 0: .Weg(39).Y = 5
        .Weg(40).X = 1: .Weg(40).Y = 5
        .Weg(41).X = 2: .Weg(41).Y = 5
        .Weg(42).X = 3: .Weg(42).Y = 5
        .Weg(43).X = 4: .Weg(43).Y = 5
    End With
    With SPIELER(1)
        .Weg(0).X = 6: .Weg(0).Y = 0
        .Weg(1).X = 6: .Weg(1).Y = 1
        .Weg(2).X = 6: .Weg(2).Y = 2
        .Weg(3).X = 6: .Weg(3).Y = 3
        .Weg(4).X = 6: .Weg(4).Y = 4
        .Weg(5).X = 7: .Weg(5).Y = 4
        .Weg(6).X = 8: .Weg(6).Y = 4
        .Weg(7).X = 9: .Weg(7).Y = 4
        .Weg(8).X = 10: .Weg(8).Y = 4
        .Weg(9).X = 10: .Weg(9).Y = 5
        .Weg(10).X = 10: .Weg(10).Y = 6
        .Weg(11).X = 9: .Weg(11).Y = 6
        .Weg(12).X = 8: .Weg(12).Y = 6
        .Weg(13).X = 7: .Weg(13).Y = 6
        .Weg(14).X = 6: .Weg(14).Y = 6
        .Weg(15).X = 6: .Weg(15).Y = 7
        .Weg(16).X = 6: .Weg(16).Y = 8
        .Weg(17).X = 6: .Weg(17).Y = 9
        .Weg(18).X = 6: .Weg(18).Y = 10
        .Weg(19).X = 5: .Weg(19).Y = 10
        .Weg(20).X = 4: .Weg(20).Y = 10
        .Weg(21).X = 4: .Weg(21).Y = 9
        .Weg(22).X = 4: .Weg(22).Y = 8
        .Weg(23).X = 4: .Weg(23).Y = 7
        .Weg(24).X = 4: .Weg(24).Y = 6
        .Weg(25).X = 3: .Weg(25).Y = 6
        .Weg(26).X = 2: .Weg(26).Y = 6
        .Weg(27).X = 1: .Weg(27).Y = 6
        .Weg(28).X = 0: .Weg(28).Y = 6
        .Weg(29).X = 0: .Weg(29).Y = 5
        .Weg(30).X = 0: .Weg(30).Y = 4
        .Weg(31).X = 1: .Weg(31).Y = 4
        .Weg(32).X = 2: .Weg(32).Y = 4
        .Weg(33).X = 3: .Weg(33).Y = 4
        .Weg(34).X = 4: .Weg(34).Y = 4
        .Weg(35).X = 4: .Weg(35).Y = 3
        .Weg(36).X = 4: .Weg(36).Y = 2
        .Weg(37).X = 4: .Weg(37).Y = 1
        .Weg(38).X = 4: .Weg(38).Y = 0
        .Weg(39).X = 5: .Weg(39).Y = 0
        .Weg(40).X = 5: .Weg(40).Y = 1
        .Weg(41).X = 5: .Weg(41).Y = 2
        .Weg(42).X = 5: .Weg(42).Y = 3
        .Weg(43).X = 5: .Weg(43).Y = 4
    End With
    With SPIELER(2)
        .Weg(0).X = 10: .Weg(0).Y = 6
        .Weg(1).X = 9: .Weg(1).Y = 6
        .Weg(2).X = 8: .Weg(2).Y = 6
        .Weg(3).X = 7: .Weg(3).Y = 6
        .Weg(4).X = 6: .Weg(4).Y = 6
        .Weg(5).X = 6: .Weg(5).Y = 7
        .Weg(6).X = 6: .Weg(6).Y = 8
        .Weg(7).X = 6: .Weg(7).Y = 9
        .Weg(8).X = 6: .Weg(8).Y = 10
        .Weg(9).X = 5: .Weg(9).Y = 10
        .Weg(10).X = 4: .Weg(10).Y = 10
        .Weg(11).X = 4: .Weg(11).Y = 9
        .Weg(12).X = 4: .Weg(12).Y = 8
        .Weg(13).X = 4: .Weg(13).Y = 7
        .Weg(14).X = 4: .Weg(14).Y = 6
        .Weg(15).X = 3: .Weg(15).Y = 6
        .Weg(16).X = 2: .Weg(16).Y = 6
        .Weg(17).X = 1: .Weg(17).Y = 6
        .Weg(18).X = 0: .Weg(18).Y = 6
        .Weg(19).X = 0: .Weg(19).Y = 5
        .Weg(20).X = 0: .Weg(20).Y = 4
        .Weg(21).X = 1: .Weg(21).Y = 4
        .Weg(22).X = 2: .Weg(22).Y = 4
        .Weg(23).X = 3: .Weg(23).Y = 4
        .Weg(24).X = 4: .Weg(24).Y = 4
        .Weg(25).X = 4: .Weg(25).Y = 3
        .Weg(26).X = 4: .Weg(26).Y = 2
        .Weg(27).X = 4: .Weg(27).Y = 1
        .Weg(28).X = 4: .Weg(28).Y = 0
        .Weg(29).X = 5: .Weg(29).Y = 0
        .Weg(30).X = 6: .Weg(30).Y = 0
        .Weg(31).X = 6: .Weg(31).Y = 1
        .Weg(32).X = 6: .Weg(32).Y = 2
        .Weg(33).X = 6: .Weg(33).Y = 3
        .Weg(34).X = 6: .Weg(34).Y = 4
        .Weg(35).X = 7: .Weg(35).Y = 4
        .Weg(36).X = 8: .Weg(36).Y = 4
        .Weg(37).X = 9: .Weg(37).Y = 4
        .Weg(38).X = 10: .Weg(38).Y = 4
        .Weg(39).X = 10: .Weg(39).Y = 5
        .Weg(40).X = 9: .Weg(40).Y = 5
        .Weg(41).X = 8: .Weg(41).Y = 5
        .Weg(42).X = 7: .Weg(42).Y = 5
        .Weg(43).X = 6: .Weg(43).Y = 5
    End With
    With SPIELER(3)
        .Weg(0).X = 4: .Weg(0).Y = 10
        .Weg(1).X = 4: .Weg(1).Y = 9
        .Weg(2).X = 4: .Weg(2).Y = 8
        .Weg(3).X = 4: .Weg(3).Y = 7
        .Weg(4).X = 4: .Weg(4).Y = 6
        .Weg(5).X = 3: .Weg(5).Y = 6
        .Weg(6).X = 2: .Weg(6).Y = 6
        .Weg(7).X = 1: .Weg(7).Y = 6
        .Weg(8).X = 0: .Weg(8).Y = 6
        .Weg(9).X = 0: .Weg(9).Y = 5
        .Weg(10).X = 0: .Weg(10).Y = 4
        .Weg(11).X = 1: .Weg(11).Y = 4
        .Weg(12).X = 2: .Weg(12).Y = 4
        .Weg(13).X = 3: .Weg(13).Y = 4
        .Weg(14).X = 4: .Weg(14).Y = 4
        .Weg(15).X = 4: .Weg(15).Y = 3
        .Weg(16).X = 4: .Weg(16).Y = 2
        .Weg(17).X = 4: .Weg(17).Y = 1
        .Weg(18).X = 4: .Weg(18).Y = 0
        .Weg(19).X = 5: .Weg(19).Y = 0
        .Weg(20).X = 6: .Weg(20).Y = 0
        .Weg(21).X = 6: .Weg(21).Y = 1
        .Weg(22).X = 6: .Weg(22).Y = 2
        .Weg(23).X = 6: .Weg(23).Y = 3
        .Weg(24).X = 6: .Weg(24).Y = 4
        .Weg(25).X = 7: .Weg(25).Y = 4
        .Weg(26).X = 8: .Weg(26).Y = 4
        .Weg(27).X = 9: .Weg(27).Y = 4
        .Weg(28).X = 10: .Weg(28).Y = 4
        .Weg(29).X = 10: .Weg(29).Y = 5
        .Weg(30).X = 10: .Weg(30).Y = 6
        .Weg(31).X = 9: .Weg(31).Y = 6
        .Weg(32).X = 8: .Weg(32).Y = 6
        .Weg(33).X = 7: .Weg(33).Y = 6
        .Weg(34).X = 6: .Weg(34).Y = 6
        .Weg(35).X = 6: .Weg(35).Y = 7
        .Weg(36).X = 6: .Weg(36).Y = 8
        .Weg(37).X = 6: .Weg(37).Y = 9
        .Weg(38).X = 6: .Weg(38).Y = 10
        .Weg(39).X = 5: .Weg(39).Y = 10
        .Weg(40).X = 5: .Weg(40).Y = 9
        .Weg(41).X = 5: .Weg(41).Y = 8
        .Weg(42).X = 5: .Weg(42).Y = 7
        .Weg(43).X = 5: .Weg(43).Y = 6
    End With
End Sub

'hat der Spieler gewrfelt, dann errechnen wir fr jede seiner 4 Figuren
'einen mglichen Zug
'ist kein Zug mglich, dann merken wir uns das auch, ansonsten merken wir
'uns auch gleich von wo und wohin sich die Figur bewegen kann
'bercksichtig wird ob die Figur noch zu Hause ist oder schon am Spielbrett unterwegs ist
Public Sub ErechneZug(ByVal spid As Integer, ByVal fid As Integer, ByVal wuerfel As Integer)
    Dim i As Integer
    Dim j As Integer
    'prfen ob figur noch zu hause
    'wenn ja, kann er raus ?
    If SPIELER(spid).ZuHause(fid) Then
        If wuerfel = 6 Then
            If SPIELFELD(SPIELER(spid).Startfeld.X, SPIELER(spid).Startfeld.Y).SpielerArrayID <> intWerHatDenWuerfel Then
                SPIELER(spid).ZugMoeglich(fid) = True
                SPIELER(spid).ZugVon(fid).X = SPIELER(spid).Figur(fid).X
                SPIELER(spid).ZugVon(fid).Y = SPIELER(spid).Figur(fid).Y
                SPIELER(spid).ZugNach(fid).X = SPIELER(spid).Startfeld.X
                SPIELER(spid).ZugNach(fid).Y = SPIELER(spid).Startfeld.Y
                Exit Sub
            End If
        End If
    End If
    'prfen ob Figur am Spielfeld
    'ziehen kann ohne sich selbst rauszuwerfen
    For i = 0 To 43
        If SPIELER(spid).Weg(i).X = SPIELER(spid).Figur(fid).X And SPIELER(spid).Weg(i).Y = SPIELER(spid).Figur(fid).Y Then
            j = i + wuerfel
            If j < 44 Then
                If SPIELFELD(SPIELER(spid).Weg(j).X, SPIELER(spid).Weg(j).Y).SpielerArrayID <> spid Then
                    SPIELER(spid).ZugMoeglich(fid) = True
                    SPIELER(spid).ZugVon(fid).X = SPIELER(spid).Figur(fid).X
                    SPIELER(spid).ZugVon(fid).Y = SPIELER(spid).Figur(fid).Y
                    SPIELER(spid).ZugNach(fid).X = SPIELER(spid).Weg(j).X
                    SPIELER(spid).ZugNach(fid).Y = SPIELER(spid).Weg(j).Y
                    Exit Sub
                End If
            End If
        End If
    Next i
End Sub

'haben wir auf eine Figur geklickt die einen Zug machen kann
'dann fhren wir jetzt diesen Zug durch
'dh. das Ausgangsfeld wird bereinigt und das Zielfeld gesetzt
'sollte sich auf dem Zielfeld eine Figur eines anderen Spielers befinden,
'dann wird dieser (har har) nach Hause geschickt
Public Sub ZugDurchfuehren(ByVal spid As Integer, ByVal fid As Integer)
    Dim i As Integer
    SPIELFELD(SPIELER(spid).ZugVon(fid).X, SPIELER(spid).ZugVon(fid).Y).SpielerArrayID = -1
    SPIELFELD(SPIELER(spid).ZugVon(fid).X, SPIELER(spid).ZugVon(fid).Y).FigurArrayID = -1
    'haben wir jemanden anderen rausgeschmissen
    If SPIELFELD(SPIELER(spid).ZugNach(fid).X, SPIELER(spid).ZugNach(fid).Y).SpielerArrayID > -1 Then
        FigurNachHauseSchicken SPIELFELD(SPIELER(spid).ZugNach(fid).X, SPIELER(spid).ZugNach(fid).Y).SpielerArrayID, _
            SPIELFELD(SPIELER(spid).ZugNach(fid).X, SPIELER(spid).ZugNach(fid).Y).FigurArrayID
    End If
    SPIELFELD(SPIELER(spid).ZugNach(fid).X, SPIELER(spid).ZugNach(fid).Y).SpielerArrayID = spid
    SPIELFELD(SPIELER(spid).ZugNach(fid).X, SPIELER(spid).ZugNach(fid).Y).FigurArrayID = fid
    SPIELER(spid).Figur(fid).X = SPIELER(spid).ZugNach(fid).X
    SPIELER(spid).Figur(fid).Y = SPIELER(spid).ZugNach(fid).Y
    If SPIELER(spid).ZuHause(fid) Then SPIELER(spid).ZuHause(fid) = False
    'ist die Figur im Ziel ?
    For i = 40 To 43
        If SPIELER(spid).ZugNach(fid).X = SPIELER(spid).Weg(i).X And _
           SPIELER(spid).ZugNach(fid).Y = SPIELER(spid).Weg(i).Y Then
            SPIELER(spid).ImZiel(fid) = True
            Exit For
        End If
    Next
    'Zug-Mglichkeiten zurcksetzen - nix geht mehr - der nchste Spieler kommt dran
    For i = 0 To 3
        SPIELER(spid).ZugMoeglich(i) = False
    Next
End Sub

'haben wir einen anderen Spieler rausgeschmissen, so schicken wir dessen Figur
'nach Hause
Public Sub FigurNachHauseSchicken(ByVal spid As Integer, ByVal fid As Integer)
    Dim i As Integer
    For i = 0 To 3
        If SPIELFELD(SPIELER(spid).HausFeld(i).X, SPIELER(spid).HausFeld(i).Y).SpielerArrayID = -1 Then
            SPIELFELD(SPIELER(spid).HausFeld(i).X, SPIELER(spid).HausFeld(i).Y).SpielerArrayID = spid
            SPIELFELD(SPIELER(spid).HausFeld(i).X, SPIELER(spid).HausFeld(i).Y).FigurArrayID = fid
            SPIELER(spid).Figur(fid).X = SPIELER(spid).HausFeld(i).X
            SPIELER(spid).Figur(fid).Y = SPIELER(spid).HausFeld(i).Y
            SPIELER(spid).ZuHause(fid) = True
            Exit For
        End If
    Next
End Sub

'hiermit kontrollieren wir nach jedem Zug ob wir vielleicht schon gewonnen haben
Public Function KontrolleObGewonnen(ByVal spid As Integer) As Boolean
    Dim bolZiel As Boolean
    Dim i As Integer
    bolZiel = True
    For i = 0 To 3
        If SPIELER(spid).ImZiel(i) = False Then
            bolZiel = False
            Exit For
        End If
    Next
    KontrolleObGewonnen = bolZiel
End Function

